1
0

install.sh 8.5 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220
  1. #!/bin/bash
  2. red='\033[0;31m'
  3. green='\033[0;32m'
  4. yellow='\033[0;33m'
  5. plain='\033[0m'
  6. cur_dir=$(pwd)
  7. # check root
  8. [[ $EUID -ne 0 ]] && echo -e "${red}Fatal error: ${plain} Please run this script with root privilege \n " && exit 1
  9. # Check OS and set release variable
  10. if [[ -f /etc/os-release ]]; then
  11. source /etc/os-release
  12. release=$ID
  13. elif [[ -f /usr/lib/os-release ]]; then
  14. source /usr/lib/os-release
  15. release=$ID
  16. else
  17. echo "Failed to check the system OS, please contact the author!" >&2
  18. exit 1
  19. fi
  20. echo "The OS release is: $release"
  21. arch() {
  22. case "$(uname -m)" in
  23. x86_64 | x64 | amd64) echo 'amd64' ;;
  24. i*86 | x86) echo '386' ;;
  25. armv8* | armv8 | arm64 | aarch64) echo 'arm64' ;;
  26. armv7* | armv7 | arm) echo 'armv7' ;;
  27. armv6* | armv6) echo 'armv6' ;;
  28. armv5* | armv5) echo 'armv5' ;;
  29. s390x) echo 's390x' ;;
  30. *) echo -e "${green}Unsupported CPU architecture! ${plain}" && rm -f install.sh && exit 1 ;;
  31. esac
  32. }
  33. echo "arch: $(arch)"
  34. os_version=""
  35. os_version=$(grep -i version_id /etc/os-release | cut -d \" -f2 | cut -d . -f1)
  36. if [[ "${release}" == "arch" ]]; then
  37. echo "Your OS is Arch Linux"
  38. elif [[ "${release}" == "manjaro" ]]; then
  39. echo "Your OS is Manjaro"
  40. elif [[ "${release}" == "armbian" ]]; then
  41. echo "Your OS is Armbian"
  42. elif [[ "${release}" == "centos" ]]; then
  43. if [[ ${os_version} -lt 8 ]]; then
  44. echo -e "${red} Please use CentOS 8 or higher ${plain}\n" && exit 1
  45. fi
  46. elif [[ "${release}" == "ubuntu" ]]; then
  47. if [[ ${os_version} -lt 20 ]]; then
  48. echo -e "${red} Please use Ubuntu 20 or higher version!${plain}\n" && exit 1
  49. fi
  50. elif [[ "${release}" == "fedora" ]]; then
  51. if [[ ${os_version} -lt 36 ]]; then
  52. echo -e "${red} Please use Fedora 36 or higher version!${plain}\n" && exit 1
  53. fi
  54. elif [[ "${release}" == "debian" ]]; then
  55. if [[ ${os_version} -lt 11 ]]; then
  56. echo -e "${red} Please use Debian 11 or higher ${plain}\n" && exit 1
  57. fi
  58. elif [[ "${release}" == "almalinux" ]]; then
  59. if [[ ${os_version} -lt 9 ]]; then
  60. echo -e "${red} Please use AlmaLinux 9 or higher ${plain}\n" && exit 1
  61. fi
  62. elif [[ "${release}" == "rocky" ]]; then
  63. if [[ ${os_version} -lt 9 ]]; then
  64. echo -e "${red} Please use Rocky Linux 9 or higher ${plain}\n" && exit 1
  65. fi
  66. elif [[ "${release}" == "oracle" ]]; then
  67. if [[ ${os_version} -lt 8 ]]; then
  68. echo -e "${red} Please use Oracle Linux 8 or higher ${plain}\n" && exit 1
  69. fi
  70. else
  71. echo -e "${red}Your operating system is not supported by this script.${plain}\n"
  72. echo "Please ensure you are using one of the following supported operating systems:"
  73. echo "- Ubuntu 20.04+"
  74. echo "- Debian 11+"
  75. echo "- CentOS 8+"
  76. echo "- Fedora 36+"
  77. echo "- Arch Linux"
  78. echo "- Manjaro"
  79. echo "- Armbian"
  80. echo "- AlmaLinux 9+"
  81. echo "- Rocky Linux 9+"
  82. echo "- Oracle Linux 8+"
  83. exit 1
  84. fi
  85. install_base() {
  86. case "${release}" in
  87. centos | almalinux | rocky | oracle)
  88. yum -y update && yum install -y -q wget curl tar tzdata
  89. ;;
  90. fedora)
  91. dnf -y update && dnf install -y -q wget curl tar tzdata
  92. ;;
  93. arch | manjaro)
  94. pacman -Syu && pacman -Syu --noconfirm wget curl tar tzdata
  95. ;;
  96. *)
  97. apt-get update && apt install -y -q wget curl tar tzdata
  98. ;;
  99. esac
  100. }
  101. # This function will be called when user installed x-ui out of security
  102. config_after_install() {
  103. echo -e "${yellow}Install/update finished! For security it's recommended to modify panel settings ${plain}"
  104. read -p "Do you want to continue with the modification [y/n]?": config_confirm
  105. if [[ "${config_confirm}" == "y" || "${config_confirm}" == "Y" ]]; then
  106. read -p "Please set up your username:" config_account
  107. echo -e "${yellow}Your username will be:${config_account}${plain}"
  108. read -p "Please set up your password:" config_password
  109. echo -e "${yellow}Your password will be:${config_password}${plain}"
  110. read -p "Please set up the panel port:" config_port
  111. echo -e "${yellow}Your panel port is:${config_port}${plain}"
  112. echo -e "${yellow}Initializing, please wait...${plain}"
  113. /usr/local/x-ui/x-ui setting -username ${config_account} -password ${config_password}
  114. echo -e "${yellow}Account name and password set successfully!${plain}"
  115. /usr/local/x-ui/x-ui setting -port ${config_port}
  116. echo -e "${yellow}Panel port set successfully!${plain}"
  117. else
  118. echo -e "${red}cancel...${plain}"
  119. if [[ ! -f "/etc/x-ui/x-ui.db" ]]; then
  120. local usernameTemp=$(head -c 6 /dev/urandom | base64)
  121. local passwordTemp=$(head -c 6 /dev/urandom | base64)
  122. /usr/local/x-ui/x-ui setting -username ${usernameTemp} -password ${passwordTemp}
  123. echo -e "this is a fresh installation,will generate random login info for security concerns:"
  124. echo -e "###############################################"
  125. echo -e "${green}username:${usernameTemp}${plain}"
  126. echo -e "${green}password:${passwordTemp}${plain}"
  127. echo -e "###############################################"
  128. echo -e "${red}if you forgot your login info,you can type x-ui and then type 8 to check after installation${plain}"
  129. else
  130. echo -e "${red} this is your upgrade,will keep old settings,if you forgot your login info,you can type x-ui and then type 8 to check${plain}"
  131. fi
  132. fi
  133. /usr/local/x-ui/x-ui migrate
  134. }
  135. install_x-ui() {
  136. cd /usr/local/
  137. if [ $# == 0 ]; then
  138. last_version=$(curl -Ls "https://api.github.com/repos/MHSanaei/3x-ui/releases/latest" | grep '"tag_name":' | sed -E 's/.*"([^"]+)".*/\1/')
  139. if [[ ! -n "$last_version" ]]; then
  140. echo -e "${red}Failed to fetch x-ui version, it maybe due to Github API restrictions, please try it later${plain}"
  141. exit 1
  142. fi
  143. echo -e "Got x-ui latest version: ${last_version}, beginning the installation..."
  144. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz
  145. if [[ $? -ne 0 ]]; then
  146. echo -e "${red}Downloading x-ui failed, please be sure that your server can access Github ${plain}"
  147. exit 1
  148. fi
  149. else
  150. last_version=$1
  151. url="https://github.com/MHSanaei/3x-ui/releases/download/${last_version}/x-ui-linux-$(arch).tar.gz"
  152. echo -e "Beginning to install x-ui $1"
  153. wget -N --no-check-certificate -O /usr/local/x-ui-linux-$(arch).tar.gz ${url}
  154. if [[ $? -ne 0 ]]; then
  155. echo -e "${red}Download x-ui $1 failed,please check the version exists ${plain}"
  156. exit 1
  157. fi
  158. fi
  159. if [[ -e /usr/local/x-ui/ ]]; then
  160. systemctl stop x-ui
  161. rm /usr/local/x-ui/ -rf
  162. fi
  163. tar zxvf x-ui-linux-$(arch).tar.gz
  164. rm x-ui-linux-$(arch).tar.gz -f
  165. cd x-ui
  166. chmod +x x-ui
  167. # Check the system's architecture and rename the file accordingly
  168. if [[ $(arch) == "armv5" || $(arch) == "armv6" || $(arch) == "armv7" ]]; then
  169. mv bin/xray-linux-$(arch) bin/xray-linux-arm
  170. chmod +x bin/xray-linux-arm
  171. fi
  172. chmod +x x-ui bin/xray-linux-$(arch)
  173. cp -f x-ui.service /etc/systemd/system/
  174. wget --no-check-certificate -O /usr/bin/x-ui https://raw.githubusercontent.com/MHSanaei/3x-ui/main/x-ui.sh
  175. chmod +x /usr/local/x-ui/x-ui.sh
  176. chmod +x /usr/bin/x-ui
  177. config_after_install
  178. systemctl daemon-reload
  179. systemctl enable x-ui
  180. systemctl start x-ui
  181. echo -e "${green}x-ui ${last_version}${plain} installation finished, it is running now..."
  182. echo -e ""
  183. echo -e "x-ui control menu usages: "
  184. echo -e "----------------------------------------------"
  185. echo -e "x-ui - Enter Admin menu"
  186. echo -e "x-ui start - Start x-ui"
  187. echo -e "x-ui stop - Stop x-ui"
  188. echo -e "x-ui restart - Restart x-ui"
  189. echo -e "x-ui status - Show x-ui status"
  190. echo -e "x-ui enable - Enable x-ui on system startup"
  191. echo -e "x-ui disable - Disable x-ui on system startup"
  192. echo -e "x-ui log - Check x-ui logs"
  193. echo -e "x-ui banlog - Check Fail2ban ban logs"
  194. echo -e "x-ui update - Update x-ui"
  195. echo -e "x-ui install - Install x-ui"
  196. echo -e "x-ui uninstall - Uninstall x-ui"
  197. echo -e "----------------------------------------------"
  198. }
  199. echo -e "${green}Running...${plain}"
  200. install_base
  201. install_x-ui $1